routes/contribs.py
from flask import Blueprint, Response, request
import flask
import json
from utils import get_db
from datetime import datetime

contribs = Blueprint('contribs', __name__)


@contribs.route('/contribs')
def index():
    """User contributions analysis.

    Call the MediaWiki server to get perform requests.
    Unauthorized users will be redirected to login page.
    """

    return flask.render_template('contribs.html')


@contribs.route('/contribs/reverts')
def reverts():
    """Find reverted edits"""
    operation = "revert"
    return flask.render_template('contribs.html', operation=operation)


@contribs.route('/contribs/save', methods=["PUT"])
def save():
    """Save the user contributions collected into database"""

    req_data = request.get_json()
    username = flask.session.get('username', "African Hope")

    # try:
    # make sure data and username are legit
    if len(req_data) > 0 and username:
        result = {
            "username": username,
            "timestamp": datetime.now().strftime('%Y-%m-%d %H:%M:%S'),
            "contribs": req_data
        }

        db = get_db()
        result_id = db.insert(result)
        result_json = json.dumps({"result_id": result_id})
        return Response(result_json, status=200, mimetype='application/json')
    # except:
        # pass

    return Response({}, status=404, mimetype='application/json')


@contribs.route('/contribs/view/<id>')
def view(id):
    """Display a search that was previously saved"""

    db = get_db()
    search = db.get(doc_id=int(id))

    return flask.render_template("contribs.html", search=search)


@contribs.route('/contribs/list')
def list():
    """List all searches performed and saved previously"""

    db = get_db()
    searches = db.all()

    return flask.render_template("list.html", searches=searches)


@contribs.route('/contribs/delete/<id>')
def delete(id):
    """Delete the user contributions collected into database"""

    notification = {"status": "error",
                    "text": "Deletion failed, an error occured."
                    }
    # Make sure item exists
    db = get_db()
    id = int(id)
    search = db.get(doc_id=id)

    if(search):
        db.remove(doc_ids=[id])
        notification['status'] = "success"
        notification['text'] = "The search was successfulled deleted."

    searches = db.all()

    return flask.render_template('list.html', searches=searches,
                                 notification=notification)

    # except:
    # pass

    return Response({}, status=404,
                    mimetype='application/json')

routes/history.py
from flask import Blueprint, Response, request
import flask
import json
from utils import get_db
from datetime import datetime

history = Blueprint('history', __name__)


@history.route('/history')
def index():
    """User contributions analysis.

    Call the MediaWiki server to get perform requests.
    Unauthorized users will be redirected to login page.
    """

    # TODO: https://www.mediawiki.org/wiki/API:Revisions#API_documentation
    return flask.render_template('history.html')

routes/home.py
import flask
from flask import Blueprint
from flask import Flask
import os
import re

app = Flask(__name__)

home = Blueprint('home', __name__)


@home.route('/')
def index():
    username = flask.session.get('username', None)
    return flask.render_template('index.html', username=username)

@home.route('/public/<path:path>')
def public(path):
    # redirect / to index.html
    if not re.match(r"^.*\.[^\\]+$", path):
        path += '/index.html'
        return flask.redirect((path))

    public_dir = os.path.join(os.path.dirname(os.path.abspath(__file__)), "../public")
    full_path = public_dir + "/" + path
    print("full_path:" + full_path)
    data = open(full_path).read()  
    return data

routes/nda.py
#!/usr/bin/env python3

# Author: Samuel Guebo
# Description: Utility for generating a list of
# users in wikicode text. It is used to populate
# m:Access to nonpublic personal data policy/Noticeboard
# License: MIT

import itertools
from flask import render_template
from flask import request
import json
import mw_api_client as mw
import re
import requests
from flask import Blueprint
from utils import app

nda = Blueprint('nda', __name__)


@nda.route('/nda',  methods=['GET', 'POST'])
def index(title=None):
    """
    Default/Home page of the application/tool.

    Keyword arguments:
    month -- the default title of the homepage
    """

    title = "Noticeboard update"
    description = "Maintenance tool for the NDA Noticeboard"
    content = old_content = ""
    user_groups = diffs = []
    summary = remote_wiki_text = ""
    noticeboard_url = app.config["NOTICEBOARD_URL"]
    phabricator_list = app.config["PHABRICATOR_LIST"]
    spreadsheet_list = app.config["SPREADSHEET_LIST"]
    namespace = app.config["NAMESPACE"]
    diff = new_users = ""
    diffs = get_diff('https://meta.wikimedia.org/w/api.php', namespace)
    page_id = list(diffs['query']['pages'])[0]
    diffs = diffs['query']['pages'][page_id]['revisions']
    step = 0


    if request.method == 'POST':
        if "previous_content" in request.form:
            old_content = request.form['previous_content']
        if "new_users" in request.form:
            new_users = request.form['new_users']
        if "diff" in request.form:
            diff = request.form['diff']

            
        # format news users
        if new_users != "":
            if len(new_users.split("\r\n")) > 1:
                summary = "+" + ", ".join(unique_list(new_users.split("\r\n")))
            else:
                summary = "+" + new_users
            new_users = text_to_users(new_users)


        if old_content != "":
            # append new_users to old_users
            old_users = get_users(old_content)
            # update new_users with diff
            if diff!= "":
                diff = diffs[0]['revid'] # update diff
                summary = []
                for user in old_users:
                    if user['status'] == 'new':
                        user['status'] = 'old'
                        user['diff'] = diff

                        summary.append(user["username"])

                summary = "+diff for " + ", ".join(summary)
               
            if len(new_users) > 0:
                user_groups = get_user_groups(old_users + new_users)
            else:
                user_groups = get_user_groups(old_users)

            header_template = re.search('\\{\\{\\:.*?\\}\\}',
                                        old_content).group(0)
            content = get_wikicode(header_template, user_groups)
            step = 2
                
                
        return render_template(
            'nda-diff.html', title=title, content=content,
            description=description, remote_wiki_text=remote_wiki_text,
            phab_list=phabricator_list, spread_list=spreadsheet_list,
            summary=summary, diffs=diffs, noticeboard_url=noticeboard_url,
            step=step, new_users=new_users
        )
    else:
        
        remote_wiki_text = get_content_from_wiki('https://meta.wikimedia.org',
                                                 namespace)

    return render_template(
        'nda-temp.html', title=title, content=content,
        description=description, remote_wiki_text=remote_wiki_text,
        phab_list=phabricator_list, spread_list=spreadsheet_list,
        summary=summary, diffs=diffs, noticeboard_url=noticeboard_url
    )


def get_group(username):
    """
    Check first character of a username and identify its group

    Keyword arguments:
    username -- a string containing the username
    """

    group = ""

    alphabet = ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L",
                "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X",
                "Y", "Z"]

    regexcharacters = '[\\!\\@\\#\\$\\%\\^\\&\\*\\(\\)\\,\\.\\?\\"\\:\\{\\}\\|\\~'
    regexcharacters += '\\<\\>\\-]'

    chars = list(username)
    first_char = ""

    if len(chars) > 0:
        first_char = chars[0]
    else:
        print(username+" could not be split")

    # check whether it's a Number
    if re.search("\\d", first_char) is not None:
        group = "Numbers"

    # check whether it's a Symbol
    elif re.search(regexcharacters, first_char) is not None:
        group = "Symbols"

    # check whether character is in Alphabet
    elif first_char.capitalize() in alphabet:
        if first_char in ["X", "Y", "Z"]:
            group = "XYZ"
        else:
            group = first_char.capitalize()

    # if not in the above, then it's 215
    else:
        group = "NonLatin"

    return group


def get_file_text(filename):
    """
    Extract text from a file

    Keyword arguments:
    filename -- the file from which the text is extracted
    """
    text = ""
    try:
        f = open(filename)

        # append characters
        for x in f:
            # chars += x
            text += x

    except Exception as e:
        print(e)
        pass

    return text


'''
def get_noticeboard_array(text):
    """
    Collect specific data from the wikicode
    and convert it into an array

    Keyword arguments:
    text -- a raw text in wikicode format
    """

    header_template = re.search("\{\{\:.*?\}\}", text).group(0)
    users = get_users(text)
    user_groups = get_user_groups(users)
    content = get_wikicode(header_template, user_groups)

    return content
'''


def get_user_groups(users):
    """
    Generate an array, grouping them by key

    Keyword arguments:
    users -- a list object containing users
    """

    # sort users so that the gouping can work
    usernames = sorted(users, key=lambda x: x['username'])
    users = []  # empty it
    user_groups = {}

    # remove duplicates
    for k, g in itertools.groupby(usernames, key=lambda x: x['username']):
        username = list(g)
        users.append(username[0])

    # group users by keyword, requires previous sorting with same key
    users = sorted(users, key=lambda x: x['group'])

    for k, g in itertools.groupby(users, key=lambda x: x['group']):

        user_groups[k] = list(g)

        # sort again by username
        user_groups[k] = sorted(user_groups[k],
                                key=lambda x: x['username'])

    return user_groups


def get_users(text):
    """
    Collect users from the wikicode
    and convert it into an array

    Keyword arguments:
    text -- a raw text in wikicode format
    """

    users = []

    users_with_diff = re.findall("\\{\\{\\/user.*", text)
    users_without_diff = re.findall("\\* \\[\\[User:.*\\]\\]", text)

    for user_line in users_with_diff:
        description = re.sub("\\{\\{.*\\}", "", user_line)  # only description
        user_line = user_line.replace(description, "")  # all but description
        diff = re.search("\\b/|\\d+", user_line).group(0)  # diff number
        username = re.sub("\\{\\{.*\\|", "",
                          user_line).replace("}", "")  # username
        group = get_group(username)

        if len(str(description)) < 2:
            description = None

        row = {
            "diff": diff,
            "username": username,
            "description": description,
            "group": group,
            "status": "old",
        }

        users.append(row)

    for user_line in users_without_diff:
        username = re.search("User\\:.*?\\]", user_line)
        if username is not None:
            username = username.group(0).replace("]", "").replace("User:", "")

        group = get_group(username)
        row = {
            "diff": "",
            "username": username,
            "description": "",
            "group": group,
            "status": "new",
        }

        users.append(row)

    return users


def get_wikicode(header_template, user_groups):
    """
    Generate a wikicode text by concatenating
    and formatting header_template and items
    of user_groups list

    Keyword arguments:
    header_template -- a transclusion in wikicode
    user_groups -- a list object containing grouped users
    """

    wikicode = ""

    # header_template, linebreak
    wikicode += header_template
    wikicode += "\n\n"

    # Number, Symbols
    for x in ["Numbers", "Symbols"]:
        if x in user_groups:
            wikicode += get_wikicode_item(x, user_groups[x])

    # A-Z
    for x in sorted(user_groups.keys()):
        if x not in ["Numbers", "Symbols", "NonLatin"]:
            wikicode += get_wikicode_item(x, user_groups[x])

    # Non-Latin
    y = "NonLatin"
    if y in user_groups:
        wikicode += get_wikicode_item(y, user_groups[y])

    return wikicode


def get_wikicode_item(header, users):
    """
    Generate a wikicode that will be used in loop
    for user_groups list

    Keyword arguments:
    header -- section header
    user_groups -- a list object containing grouped users
    """

    wikicode = ""

    # edge case
    if header == "NonLatin":
        wikicode += '<span id="Nonlatin"></span>'  # Id for navigation
        wikicode += "\n"
        header = "Non-Latin"

    if header == "XYZ":
        wikicode += '<span id="X"></span><span id="Y">'
        wikicode += '</span><span id="Z"></span>'
        wikicode += "\n"

    wikicode += "=== " + header + " ==="
    wikicode += "\n"

    for user in users:
        if(user['status'] == 'new'):
            wikicode += "* [[User:" + user['username'] + "]]"
        else:
            wikicode += "{{/user|" + str(user['diff']) + "|"
            wikicode += user['username'] + "}}"
        if user['description']:
            wikicode += user['description']
        wikicode += "\n"

    wikicode += "\n"

    return wikicode


def text_to_users(text):
    """

templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
	<title>{{title}} | {{description}}</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="//tools-static.wmflabs.org/cdnjs/ajax/libs/bootstrap-datepicker/1.7.1/css/bootstrap-datepicker.min.css" />
	<link rel="stylesheet" href="//tools-static.wmflabs.org/cdnjs/ajax/libs/twitter-bootstrap/4.0.0/css/bootstrap.min.css">
	<link rel="stylesheet" href="{{url_for('static', filename='css/main.css')}}" />
	<link href="//tools-static.wmflabs.org/cdnjs/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css" rel="stylesheet">
	<script src="//tools-static.wmflabs.org/cdnjs/ajax/libs/jquery/3.3.1/jquery.js"></script>
	<script src="//tools-static.wmflabs.org/cdnjs/ajax/libs/twitter-bootstrap/4.0.0/js/bootstrap.min.js"></script>
	<script src="//tools-static.wmflabs.org/cdnjs/ajax/libs/bootstrap-datepicker/1.7.1/js/bootstrap-datepicker.min.js"></script>
</head>
<body>
	<nav class="navbar navbar-dark bg-primary navbar-expand-lg">
		<div class="container">
			<button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
				<span class="navbar-toggler-icon"></span>
			</button>

			<div class="collapse navbar-collapse" id="navbarSupportedContent">
				<ul class="navbar-nav mr-auto">
					<!-- Home page -->
					<li class="nav-item">
						<a class="nav-link" href="{{url_for('home.index', _external=True, _scheme=scheme)}}" id="baseurl">
							<i class="fa fa-home"></i> Home <span class="sr-only">(current)</span>
						</a>
					</li>
					{% if username and usergroup %}
					<li class="nav-item"></li>
						<a class="nav-link" href="{{url_for('nda.index', _external=True, _scheme=scheme)}}">
							<i class="fa fa-shield"></i> NDA noticeboard
						</a>
					</li>
					{% endif %}
					<li class="nav-item">
						<a class="nav-link" href="https://meta.wikimedia.org/wiki/Trust_and_Safety" target="_blank">
							<i class="fa fa-users"></i> About T&S
						</a>
					</li>
				</ul>
			</div>
		</div>
	</nav>
	<br>
	<br>
	<div class="container-fluid">
		<div class="row content">
			{% block content %}{% endblock %}
		</div>
		<br>
		<br>

	</div>
	<footer class="container footer">
		<hr class="featurette-divider">
		<div id="footer">
			<div class="container">
				<div class="row">
					<div class="col-md-6">
					<a href="https://wikimediafoundation.org/wiki/Privacy_policy">Privacy Policy</a> |
					<a href="https://wikitech.wikimedia.org/wiki/Wikitech:Labs_Terms_of_use">Terms of Use</a> |
					<a href="https://phabricator.wikimedia.org/maniphest/task/create/?projects=trust-and-safety">Report a bug!</a>
					</div>
					<div class="pull-right">
						Hosted on <a href="https://wikitech.wikimedia.org/wiki/Portal:Cloud_VPS">Wikimedia Cloud VPS</a>, written in <a href="https://python.org">Python</a> by <a href="https://meta.wikimedia.org/wiki/Samuel_(WMF)">Samuel (WMF)</a>
					</div>
				</div>
			</div>
		</div>
		<script src="{{url_for('static', filename='js/main.js')}}"></script>
	</footer>

</body>
</html>

templates/contribs.html
{% extends "base.html" %}
{% block content %}
<div class="container">
	<section id="contribs-form-wrapper">
		{% if not search %}
			<section  class="col-md-8 no-pad">
				<h1>User edits</h1>
				<form>
					<div class="form-group">
					<label for="username">Username:</label>
					<input type="text" class="form-control"
						id="username" name="username" value="Cruks">
					</div>
					<div class="form-group">
					<label for="wiki">Wiki:</label>
					<input type="text" class="form-control"
						id="wiki" name="wiki"  value="de.wikipedia.org"
						placeholder="de.wikipedia.org">
					</div>
					<div class="form-group" id="operations">
					{% if operation %}
					<!-- Default unchecked -->
					<select name = "operation" class="browser-default custom-select">
						<option selecte value="revert">Reverted edits</option>
						<option value="deletion">Deletes edits</option>
					</select>
					{% endif %}
					</div>
					<button id="btn-search" type="submit" class="btn btn-secondary"><i class="fa fa-search"></i> Search</button>
					<button id="btn-save" class="btn btn-success"><i class="fa fa-save"></i> Save</button>
					<strong id="notification"></strong>
				</form>
			</section>
			<hr class="my-4">
		{% endif %}



		<h2>Results
			{% if search %}
			<a id="btn-reset" href="{{url_for('contribs.delete', id=search.doc_id)}}" class="btn btn-small btn-danger float-right">
				<i class="fa fa-remove"></i> Delete</a>
			{% else %}
			<a id="btn-reset" href="#" class="btn btn-small btn-danger float-right">
				<i class="fa fa-remove"></i> Reset</a>
			{% endif %}
		</h2>

		<table id="contribs-table" class="table table-striped">
			<thead>
				<tr>
					<th>ID</th>
					<th>Timestamp</th>
					<th>Revid</th>
					<th>User</th>
					<th>Title</th>
					<th>Comment</th>
				</tr>
			</thead>
			<tbody>
				{% if search %}
					{% for contrib in search.contribs %}
					<tr>
						<td>{{loop.index}}</td>
						<td>{{contrib.timestamp}}</td>
						<td>{{contrib.revid}}</td>
						<td>{{contrib.user}}</td>
						<td>{{contrib.title}}</td>
						<td>{{contrib.comment}}</td>
					</tr>
					{% endfor %}
				{% endif %}

			</tbody>
		</table>
	</section>
</div>
{% endblock %}

templates/history.html
{% extends "base.html" %}
{% block content %}
<div class="container">
	<section id="contribs-form-wrapper">
		{% if not search %}
			<section  class="col-md-8 no-pad">
				<h1>Page history</h1>
				<form id="history-form">

					<div class="form-group">
                        <label for="wiki">Wiki:</label>
                        <input type="text" class="form-control"
                            id="wiki" name="wiki"  value="fr.wikipedia.org"
                            placeholder="fr.wikipedia.org">
                    </div>
                    <div class="form-group">
                            <label for="wiki">Name space:</label>
                            <input type="text" class="form-control"
                                placeholder="User:African Hope">
                        </div>
                    <!-- date rage -->
                    <div class="form-group row">
                        <div class="col-md-4">
                            <label for="month">Since:</label>
                            <input class="form-control datepicker" name="from-date" placeholder="yyyy-mm-dd">
                        </div>
                        <div class="col-md-4">
                            <label for="month">Until:</label>
                            <input class="form-control datepicker" name="to-date" placeholder="yyyy-mm-dd">
                        </div>
                        <div class="col-md-4" id="operations">
                            <button id="btn-search" type="submit" class="btn btn-secondary"><i class="fa fa-search"></i> Search</button>
                            <button id="btn-save" class="btn btn-success"><i class="fa fa-save"></i> Save</button>
                            <strong id="notification"></strong>
                        </div>
					</div>
					
				</form>
			</section>
			<hr class="my-4">
		{% endif %}



		<h2>Results
			{% if search %}
			<a id="btn-reset" href="{{url_for('contribs.delete', id=search.doc_id)}}" class="btn btn-small btn-danger float-right">
				<i class="fa fa-remove"></i> Delete</a>
			{% else %}
			<a id="btn-reset" href="#" class="btn btn-small btn-danger float-right">
				<i class="fa fa-remove"></i> Reset</a>
			{% endif %}
		</h2>

		<table id="contribs-table" class="table table-striped">
			<thead>
				<tr>
					<th>ID</th>
					<th>Timestamp</th>
					<th>Revid</th>
					<th>User</th>
					<th>Title</th>
					<th>Comment</th>
				</tr>
			</thead>
			<tbody>
				{% if search %}
					{% for contrib in search.contribs %}
					<tr>
						<td>{{loop.index}}</td>
						<td>{{contrib.timestamp}}</td>
						<td>{{contrib.revid}}</td>
						<td>{{contrib.user}}</td>
						<td>{{contrib.title}}</td>
						<td>{{contrib.comment}}</td>
					</tr>
					{% endfor %}
				{% endif %}

			</tbody>
		</table>
    </section>
    <script>
        // Date picker 
        $( '.datepicker' ).datepicker( {
            format: 'yyyy-mm-dd',
        } )    
    </script>
</div>
{% endblock %}

templates/index.html
{% extends "base.html" %}
{% block content %}
<div class="container">

	<div class="jumbotron">
		<h1 class="display-4">{{title}}</h1>
		<p class="lead"></p>
		<p class="lead">{{description}}</p>
		{% if username %}
			<hr class="my-4">
			<p>{{greeting}} {{ username }}!
				{% if usergroup != 'wmf-supportsafety' %}
				<br>
				<strong>Sorry, your account does not have
					<span class="badge badge-danger">T&S Credentials</span>
				</strong>
				{% endif %}
			</p>
			<p><a class="btn btn-primary btn-lg" href="{{ url_for('auth.logout') }}">logout</a></p>

        {% else %}
		<p class="lead">
			<a class="btn btn-primary btn-lg" href="{{ url_for('auth.login') }}" role="button">Login via Meta-wiki</a>
		</p>
        {% endif %}
	</div>
</div>
{% endblock %}

templates/list.html
{% extends "base.html" %}
{% block content %}
<div class="container">
	<section id="contribs-form-wrapper">
		{% if notification %}
			{% if notification.status == "success" %}
				<div class="alert alert-success" role="alert">
					{{ notification.text }}
				</div>
			{% else %}
				<div class="alert alert-warning" role="alert">
					{{ notification.text }}
				</div>
			{% endif %}
		{% endif %}
		<h2>Results</h2>

		<table id="contribs-table" class="table table-striped">
			<thead>
				<tr>
					<th>ID</th>
					<th>Performer</th>
					<th>Timestamp</th>
					<th>Results</th>
					<th>Link</th>
					<th>Manage</th>
				</tr>
			</thead>
			<tbody>
				{% if searches %}
					{% for search in searches%}
					<tr>
						<td>{{loop.index}}</td>
						<td>{{search.username}}</td>
						<td>{{search.timestamp}}</td>
						<td>{{search.contribs|length}}</td>
						<td>
							<a href="{{url_for('contribs.view', id=search.doc_id)}}"
								class="float-left"
								title="Result collected by {{search.username}}">
								{{url_for('contribs.view', id=search.doc_id)}}
							</a>
						</td>
						<td>
							<a href="{{url_for('contribs.delete', id=search.doc_id)}}"
								class="btn btn-danger"
								title="Delete this result">
								<i class="fa fa-remove"></i> Delete
							</a>
						</td>
					</tr>
					{% endfor %}
				{% endif %}

			</tbody>
		</table>
	</section>
</div>
{% endblock %}

templates/nda-diff.html
{% extends "base.html" %}
{% block content %}
<div class="container">
	<div class="form-group">
		<h1 class="clearfix">{{title}}</h1> 
		<a class="btn btn-success btn-sm" href="{{phab_list}}">Phabricator</a>
		<a class="btn btn-success btn-sm" href="{{spread_list}}">Spreadsheet</a>
	</div>
	<div class="row">


		<div class="form-group col-md-6">	
			<form "{{ url_for('nda.index') }}" method="post">
				<div class="form-group">
					<textarea name="previous_content" class="form-control" rows="5" cols="80" style="display:none" >{{content}}</textarea>
				</div>
				<label for="new_users">Output</label>
				<textarea class="form-control" rows="7" cols="80">{{content}}</textarea>
	
				<label for="summary">Summary</label>
				<input name="summary" type="text" class="form-control" rows="3" value="{{summary}}"><br>
	
				<!-- New users 
				{% if new_users != "" %}
				<div class="form-group">
					<label for="new_users">New users</label>
					<textarea name="new_users" class="form-control" rows="5" cols="80" style="display: none;">{% for user in new_users %}{{user.username}}{% endfor %}</textarea>
				</div>
				{% endif %}
				-->
				<!-- Diffs -->
				{% if diffs %}
				<div class="list-group">
				<a href="#" class="list-group-item active">Latest diff</a>
					{% for diff in diffs %}
						<p class="list-group-item">
							<a href="https://meta.wikimedia.org/wiki/Special:Diff/{{diff.revid}}">{{diff.revid}}</a> by {{diff.user}} // {{diff.comment}}
						</p>
					{% endfor %}
					{% if step == 2 %}
					<input name="diff" type="hidden" class="form-control" rows="3" value="{{diffs[0].revid}}">
					{% endif %}
				</div>
				{% endif %}
				<br>
				
				<button type="submit" class="btn btn-primary mb-2">Generate diff</button> 
				<a class="btn btn-dark mb-2" href="{{ url_for('nda.index') }}"><i class="fa fa-refresh"></i> Reset</a>
				<a class="btn btn-danger mb-2" href="{{noticeboard_url}}" target="_blank"><i class="fa fa-edit"></i> Edit page</a>
			</form>
		</div>



	</div>
</div>
{% endblock %}

templates/nda-temp.html
{% extends "base.html" %}
{% block content %}

<div class="container">
	<div class="form-group">
		<h1 class="clearfix">{{title}}</h1> 
		<a class="btn btn-success btn-sm" href="{{phab_list}}">Phabricator</a>
		<a class="btn btn-success btn-sm" href="{{spread_list}}">Spreadsheet</a>
	</div>
	<div class="row">

		<form "{{ url_for('nda.index') }}" method="post" class="col-md-6">

				<div class="form-group">
						<textarea name="previous_content" class="form-control" rows="5" cols="80" style="display:none" >{{remote_wiki_text}}</textarea>
				</div>

				<div class="form-group">
						<label for="new_users">New users</label>
						<textarea name="new_users" class="form-control" rows="5" cols="80" placeholder="One user perline"></textarea>
				</div>

				<!-- Diffs -->
			{% if diffs %}
			<div class="list-group">
			  <a href="#" class="list-group-item active">Latest diff</a>
				{% for diff in diffs %}
					<p class="list-group-item">
						<a href="https://meta.wikimedia.org/wiki/Special:Diff/{{diff.revid}}">{{diff.revid}}</a> by {{diff.user}} // {{diff.comment}}
					</p>
				{% endfor %}
			</div>
			{% endif %}
			<br>
			<button type="submit" class="btn btn-primary mb-2">Generate</button>
			<a class="btn btn-danger mb-2" href="{{noticeboard_url}}" target="_blank"><i class="fa fa-edit"></i> Edit page</a>
			
		</form>



	</div>
</div>
{% endblock %}